3.0.0-beta09 (latest) 3.0.0-beta08 2.0.0-beta08

    public sealed class AppEngineHttpRequest : IMessage<AppEngineHttpRequest>, IEquatable<AppEngineHttpRequest>, IDeepCloneable<AppEngineHttpRequest>, IBufferMessage, IMessage

Reference documentation and code samples for the Google Cloud Tasks v2beta3 API class AppEngineHttpRequest.

App Engine HTTP request.

The message defines the HTTP request that is sent to an App Engine app when
the task is dispatched.

Using \[AppEngineHttpRequest\]\[google.cloud.tasks.v2beta3.AppEngineHttpRequest\]
requires
[`appengine.applications.get`](https://cloud.google.com/appengine/docs/admin-api/access-control)
Google IAM permission for the project
and the following scope:

`https://www.googleapis.com/auth/cloud-platform`

The task will be delivered to the App Engine app which belongs to the same
project as the queue. For more information, see
[How Requests are
Routed](https://cloud.google.com/appengine/docs/standard/python/how-requests-are-routed)
and how routing is affected by
[dispatch
files](https://cloud.google.com/appengine/docs/python/config/dispatchref).
Traffic is encrypted during transport and never leaves Google datacenters.
Because this traffic is carried over a communication mechanism internal to
Google, you cannot explicitly set the protocol (for example, HTTP or HTTPS).
The request to the handler, however, will appear to have used the HTTP
protocol.

The \[AppEngineRouting\]\[google.cloud.tasks.v2beta3.AppEngineRouting\] used to
construct the URL that the task is delivered to can be set at the queue-level
or task-level:

- If set, \[app_engine_routing_override\]\[google.cloud.tasks.v2beta3.AppEngineHttpQueue.app_engine_routing_override\] is used for all tasks in the queue, no matter what the setting is for the \[task-level app_engine_routing\]\[google.cloud.tasks.v2beta3.AppEngineHttpRequest.app_engine_routing\].

The `url` that the task will be sent to is:

- `url =` \[host\]\[google.cloud.tasks.v2beta3.AppEngineRouting.host\] `+` \[relative_uri\]\[google.cloud.tasks.v2beta3.AppEngineHttpRequest.relative_uri\]

Tasks can be dispatched to secure app handlers, unsecure app handlers, and
URIs restricted with
[`login:
admin`](https://cloud.google.com/appengine/docs/standard/python/config/appref).
Because tasks are not run as any user, they cannot be dispatched to URIs
restricted with
[`login:
required`](https://cloud.google.com/appengine/docs/standard/python/config/appref)
Task dispatches also do not follow redirects.

The task attempt has succeeded if the app's request handler returns an HTTP
response code in the range \[`200` - `299`\]. The task attempt has failed if
the app's handler returns a non-2xx response code or Cloud Tasks does
not receive response before the
\[deadline\]\[google.cloud.tasks.v2beta3.Task.dispatch_deadline\]. Failed tasks
will be retried according to the \[retry
configuration\]\[google.cloud.tasks.v2beta3.Queue.retry_config\]. `503` (Service
Unavailable) is considered an App Engine system error instead of an
application error and will cause Cloud Tasks' traffic congestion control to
temporarily throttle the queue's dispatches. Unlike other types of task
targets, a `429` (Too Many Requests) response from an app handler does not
cause traffic congestion control to throttle the queue.

## Inheritance

[object](https://learn.microsoft.com/dotnet/api/system.object) \> AppEngineHttpRequest

## Implements

[IMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IMessage-1.html)[AppEngineHttpRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.AppEngineHttpRequest), [IEquatable](https://learn.microsoft.com/dotnet/api/system.iequatable-1)[AppEngineHttpRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.AppEngineHttpRequest), [IDeepCloneable](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IDeepCloneable-1.html)[AppEngineHttpRequest](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.AppEngineHttpRequest), [IBufferMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IBufferMessage.html), [IMessage](https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.IMessage.html)

## Inherited Members

[object.GetHashCode()](https://learn.microsoft.com/dotnet/api/system.object.gethashcode) [object.GetType()](https://learn.microsoft.com/dotnet/api/system.object.gettype) [object.ToString()](https://learn.microsoft.com/dotnet/api/system.object.tostring)

## Namespace

[Google.Cloud.Tasks.V2Beta3](https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3)

## Assembly

Google.Cloud.Tasks.V2Beta3.dll

## Constructors

### AppEngineHttpRequest()

    public AppEngineHttpRequest()

### AppEngineHttpRequest(AppEngineHttpRequest)

    public AppEngineHttpRequest(AppEngineHttpRequest other)

| **Parameter** ||
|---|---|
| **Name** | **Description** |
| `other` | `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.AppEngineHttpRequest` |

## Properties

### AppEngineRouting

    public AppEngineRouting AppEngineRouting { get; set; }

Task-level setting for App Engine routing.

If set,
\[app_engine_routing_override\]\[google.cloud.tasks.v2beta3.AppEngineHttpQueue.app_engine_routing_override\]
is used for all tasks in the queue, no matter what the setting is for the
\[task-level
app_engine_routing\]\[google.cloud.tasks.v2beta3.AppEngineHttpRequest.app_engine_routing\].

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.AppEngineRouting` |   |

### Body

    public ByteString Body { get; set; }

HTTP request body.

A request body is allowed only if the HTTP method is POST or PUT. It is
an error to set a body on a task with an incompatible
\[HttpMethod\]\[google.cloud.tasks.v2beta3.HttpMethod\].

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.ByteString.html` |   |

### Headers

    public MapField<string, string> Headers { get; }

HTTP request headers.

This map contains the header field names and values.
Headers can be set when the
\[task is created\]\[google.cloud.tasks.v2beta3.CloudTasks.CreateTask\].
Repeated headers are not supported but a header value can contain commas.

Cloud Tasks sets some headers to default values:

- `User-Agent`: By default, this header is `"AppEngine-Google; (+http://code.google.com/appengine)"`. This header can be modified, but Cloud Tasks will append `"AppEngine-Google; (+http://code.google.com/appengine)"` to the modified `User-Agent`.

If the task has a
\[body\]\[google.cloud.tasks.v2beta3.AppEngineHttpRequest.body\], Cloud Tasks
sets the following headers:

- `Content-Type`: By default, the `Content-Type` header is set to `"application/octet-stream"`. The default can be overridden by explicitly setting `Content-Type` to a particular media type when the \[task is created\]\[google.cloud.tasks.v2beta3.CloudTasks.CreateTask\]. For example, `Content-Type` can be set to `"application/json"`.
- `Content-Length`: This is computed by Cloud Tasks. This value is output only. It cannot be changed.

The headers below cannot be set or overridden:

- `Host`
- `X-Google-*`
- `X-AppEngine-*`

In addition, Cloud Tasks sets some headers when the task is dispatched,
such as headers containing information about the task; see
[request
headers](https://cloud.google.com/tasks/docs/creating-appengine-handlers#reading_request_headers).
These headers are set only when the task is dispatched, so they are not
visible when the task is returned in a Cloud Tasks response.

Although there is no specific limit for the maximum number of headers or
the size, there is a limit on the maximum size of the
\[Task\]\[google.cloud.tasks.v2beta3.Task\]. For more information, see the
\[CreateTask\]\[google.cloud.tasks.v2beta3.CloudTasks.CreateTask\]
documentation.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://cloud.google.com/dotnet/docs/reference/Google.Protobuf/latest/Google.Protobuf.Collections.MapField-2.htmlhttps://learn.microsoft.com/dotnet/api/system.stringhttps://learn.microsoft.com/dotnet/api/system.string` |   |

### HttpMethod

    public HttpMethod HttpMethod { get; set; }

The HTTP method to use for the request. The default is POST.

The app's request handler for the task's target URL must be able to handle
HTTP requests with this http_method, otherwise the task attempt fails with
error code 405 (Method Not Allowed). See [Writing a push task request
handler](https://cloud.google.com/appengine/docs/java/taskqueue/push/creating-handlers#writing_a_push_task_request_handler)
and the App Engine documentation for your runtime on [How Requests are
Handled](https://cloud.google.com/appengine/docs/standard/python3/how-requests-are-handled).

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://docs.cloud.google.com/dotnet/docs/reference/Google.Cloud.Tasks.V2Beta3/latest/Google.Cloud.Tasks.V2Beta3.HttpMethod` |   |

### RelativeUri

    public string RelativeUri { get; set; }

The relative URI.

The relative URI must begin with "/" and must be a valid HTTP relative URI.
It can contain a path and query string arguments.
If the relative URI is empty, then the root path "/" will be used.
No spaces are allowed, and the maximum length allowed is 2083 characters.

| **Property Value** ||
|---|---|
| **Type** | **Description** |
| `https://learn.microsoft.com/dotnet/api/system.string` |   |